using System;
using System.IO;
using System.ComponentModel;
using System.Text;

namespace id.Quake.Files {

	public partial class Model {

		/// <summary>Represents a texture coordinate.</summary>
		public class TextureCoordinate {

			#region Properties

			private bool isOnSeam;
			/// <summary>True if the texture coordinate is on the seam of a model.</summary>
			public bool IsOnSeam { get { return this.isOnSeam; } }

			private int x;
			public int X {
				get { return this.x; }
			}

			private int y;
			public int Y {
				get { return this.y; }
			}
			
			public override string ToString() {
				return string.Format("{{{0}, {1}}}", x, y);
			}

			#endregion

			#region Private Members

			private readonly Model Model;

			#endregion

			

			public TextureCoordinate(Model model, Stream stream) {
				this.Model = model;
				BinaryReader TextureCoordinateReader = new BinaryReader(stream);
				this.isOnSeam = TextureCoordinateReader.ReadUInt32() != 0;
				this.x = TextureCoordinateReader.ReadInt32();
				this.y = TextureCoordinateReader.ReadInt32();				
			}


			
			


		}

		
	}
}
