using System;
using System.IO;
using System.ComponentModel;
using System.Text;

namespace id.Quake.Files {

	[SupportedExtension("lmp")]
	public class Palette : INamedResource {

		#region Properties

		
		private int[] colours;
		public int[] Colours {
			get { return this.colours; }
		}

		private readonly ResourceLoader Resources;

		private string name;
		[Browsable(false)]
		public string Name { get { return this.name; } set { this.name = value; } }

		[Browsable(false)]
		public bool NamedInternally { get { return false; } }

		#endregion


		#region Constructor

		public Palette(ResourceLoader resources, Stream stream) {

			this.Resources = resources;

			BinaryReader PaletteReader = new BinaryReader(stream);
			this.colours = new int[256];

			for (int i = 0; i < 256; ++i) {
				byte[] rgb = PaletteReader.ReadBytes(3);
				this.colours[i] = unchecked((rgb[0] << 16) | (rgb[1] << 8) | (rgb[2] << 0) | (int)(0xFF000000));
			}
		

		}

		#endregion

	}
}
