using System;
using System.Collections.Generic;
using System.Text;

using QuakeC = id.Quake.Files.QuakeC;

namespace id.Quake.Files {
	public partial class QuakeC {

		public enum GlobalVariableOffsets : uint {
			Null = 0,
			Return = 1,
			Parameter0 = 4,
			Parameter1 = 7,
			Parameter2 = 10,
			Parameter3 = 13,
			Parameter4 = 16,
			Parameter5 = 19,
			Parameter6 = 22,
			Parameter7 = 25,
			Reserved = 28,
		}


		private QuakeC.VariablePointer GetGlobal(uint offset) {
			return new QuakeC.VariablePointer(this, offset);
		}

		private QuakeC.VariablePointer GetGlobal(GlobalVariableOffsets offset) {
			return new QuakeC.VariablePointer(this, (uint)(offset) * 4);
		}

		private EdictCollection.Edict GetGlobalEdict(GlobalVariableOffsets offset) {
			return new EdictCollection.Edict(this.edicts, this.GetGlobal(offset).Integer);
		}

		private void SetGlobal(uint offset, float value) {
			new QuakeC.VariablePointer(this, offset, Definition.DataType.Float).Float = value;
		}

		private void SetGlobal(GlobalVariableOffsets offset, float value) {
			this.SetGlobal(4 * (uint)offset, value);
		}

		private void SetGlobal(uint offset, Vector3 value) { new QuakeC.VariablePointer(this, offset, Definition.DataType.Vector).Vector = value; }
		private void SetGlobal(GlobalVariableOffsets offset, Vector3 value) { this.SetGlobal(4 * (uint)offset, value); }
		private void SetGlobal(Definition offset, Vector3 value) { this.SetGlobal(4 * (uint)offset.Offset, value); }

		private void SetGlobal(uint offset, EdictCollection.Edict value) {
			VariablePointer VP = new QuakeC.VariablePointer(this, offset, Definition.DataType.Entity);
			VP.Integer = this.Edicts.GetIndex(value);
		}

		private void SetGlobal(GlobalVariableOffsets offset, EdictCollection.Edict value) {
			this.SetGlobal(4 * (uint)offset, value);
		}

		private QuakeC.VariablePointer Parameter0 { get { return this.GetGlobal(GlobalVariableOffsets.Parameter0); } }
		private QuakeC.VariablePointer Parameter1 { get { return this.GetGlobal(GlobalVariableOffsets.Parameter1); } }
		private QuakeC.VariablePointer Parameter2 { get { return this.GetGlobal(GlobalVariableOffsets.Parameter2); } }
		private QuakeC.VariablePointer Parameter3 { get { return this.GetGlobal(GlobalVariableOffsets.Parameter3); } }
		private QuakeC.VariablePointer Parameter4 { get { return this.GetGlobal(GlobalVariableOffsets.Parameter4); } }
		private QuakeC.VariablePointer Parameter5 { get { return this.GetGlobal(GlobalVariableOffsets.Parameter5); } }
		private QuakeC.VariablePointer Parameter6 { get { return this.GetGlobal(GlobalVariableOffsets.Parameter6); } }
		private QuakeC.VariablePointer Parameter7 { get { return this.GetGlobal(GlobalVariableOffsets.Parameter7); } }
		private QuakeC.VariablePointer Return { get { return this.GetGlobal(GlobalVariableOffsets.Return); } }

	}
}
