using System;
using System.ComponentModel;

namespace id.Quake {


	/// <summary>Defines a vector made up of three <c>short</c> components.</summary>
	public struct Vector3Short {
				
		/// <summary>Gets or sets the X component of the vector.</summary>
		public short X;
		/// <summary>Gets or sets the Y component of the vector.</summary>
		public short Y;
		/// <summary>Gets or sets the Z component of the vector.</summary>
		public short Z;

		/// <summary>Initialise a Vector3Short specifing values for all three component values.</summary>
		public Vector3Short(short x, short y, short z) {
			this.X = x; this.Y = y; this.Z = z;
		}

		/// <summary>Gets a formatted string describing the vector's components.</summary>
		public override string ToString() {
			return string.Format("'{0} {1} {2}'", this.X, this.Y, this.Z);
		}

		/// <summary>Converts a Vector3Short into a Vector3.</summary>
		/// <param name="vector">The vector to convert.</param>
		public static implicit operator Vector3(Vector3Short vector) {
			return new Vector3(vector.X, vector.Y, vector.Z);
		}

		/// <summary>Converts a Vector3Short into a Vector3.</summary>
		/// <param name="vector">The vector to convert.</param>
		public static explicit operator Vector3Short(Vector3 vector) {
			return new Vector3Short((short)vector.X, (short)vector.Y, (short)vector.Z);
		}
	}


}