using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace Ranger {
	static class Program {

		#region FMOD
		
		internal static FMOD.System SoundSystem = null;
		internal static void FmodErrorCheck(FMOD.RESULT result) { if (result != FMOD.RESULT.OK) throw new ApplicationException(result.ToString()); }
		
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() {
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);

			// FMOD Ex:
			FmodErrorCheck(FMOD.Factory.System_Create(ref SoundSystem));
			uint version = 0;
			FmodErrorCheck(SoundSystem.getVersion(ref version));
			if (version < FMOD.VERSION.number) throw new ApplicationException("Requires FMOD version " + FMOD.VERSION.number + ".");
			FmodErrorCheck(SoundSystem.init(32, FMOD.INITFLAG.NORMAL, (IntPtr)null));

			Application.Run(new RangerFrontEnd());
		}
	}
}