using System;
using System.Runtime.InteropServices;

namespace XnaQuake {
	public static class CdAudio {

		enum MciError {
			AVI_AUDIOERROR = (CUSTOM_DRIVER_BASE + 107),
			AVI_BADPALETTE = (CUSTOM_DRIVER_BASE + 108),
			AVI_CANTPLAYFULLSCREEN = (CUSTOM_DRIVER_BASE + 103),
			AVI_DISPLAYERROR = (CUSTOM_DRIVER_BASE + 106),
			AVI_NOCOMPRESSOR = (CUSTOM_DRIVER_BASE + 105),
			AVI_NODISPDIB = (CUSTOM_DRIVER_BASE + 102),
			AVI_NOTINTERLEAVED = (CUSTOM_DRIVER_BASE + 101),
			AVI_OLDAVIFORMAT = (CUSTOM_DRIVER_BASE + 100),
			AVI_TOOBIGFORVGA = (CUSTOM_DRIVER_BASE + 104),
			BAD_CONSTANT = (BASE + 34),
			BAD_INTEGER = (BASE + 14),
			BAD_TIME_FORMAT = (BASE + 37),
			BASE = 256,
			CANNOT_LOAD_DRIVER = (BASE + 10),
			CANNOT_USE_ALL = (BASE + 23),
			CREATEWINDOW = (BASE + 91),
			CUSTOM_DRIVER_BASE = (BASE + 256),
			DEVICE_LENGTH = (BASE + 54),
			DEVICE_LOCKED = (BASE + 32),
			DEVICE_NOT_INSTALLED = (BASE + 50),
			DEVICE_NOT_READY = (BASE + 20),
			DEVICE_OPEN = (BASE + 9),
			DEVICE_ORD_LENGTH = (BASE + 55),
			DEVICE_TYPE_REQUIRED = (BASE + 31),
			DGV_BAD_CLIPBOARD_RANGE = (CUSTOM_DRIVER_BASE + 5),
			DGV_DEVICE_LIMIT = (CUSTOM_DRIVER_BASE + 0),
			DGV_DEVICE_MEMORY_FULL = (CUSTOM_DRIVER_BASE + 4),
			DGV_DISK_FULL = (CUSTOM_DRIVER_BASE + 3),
			DGV_IOERR = (CUSTOM_DRIVER_BASE + 1),
			DGV_WORKSPACE_EMPTY = (CUSTOM_DRIVER_BASE + 2),
			DRIVER = (BASE + 22),
			DRIVER_INTERNAL = (BASE + 16),
			DUPLICATE_ALIAS = (BASE + 33),
			DUPLICATE_FLAGS = (BASE + 39),
			EXTENSION_NOT_FOUND = (BASE + 25),
			EXTRA_CHARACTERS = (BASE + 49),
			FILE_NOT_FOUND = (BASE + 19),
			FILE_NOT_SAVED = (BASE + 30),
			FILE_READ = (BASE + 92),
			FILE_WRITE = (BASE + 93),
			FILENAME_REQUIRED = (BASE + 48),
			FLAGS_NOT_COMPATIBLE = (BASE + 28),
			GET_CD = (BASE + 51),
			HARDWARE = (BASE + 6),
			ILLEGAL_FOR_AUTO_OPEN = (BASE + 47),
			INTERNAL = (BASE + 21),
			INVALID_DEVICE_ID = (BASE + 1),
			INVALID_DEVICE_NAME = (BASE + 7),
			INVALID_FILE = (BASE + 40),
			MISSING_COMMAND_STRING = (BASE + 11),
			MISSING_DEVICE_NAME = (BASE + 36),
			MISSING_PARAMETER = (BASE + 17),
			MISSING_STRING_ARGUMENT = (BASE + 13),
			MULTIPLE = (BASE + 24),
			MUST_USE_SHAREABLE = (BASE + 35),
			NEW_REQUIRES_ALIAS = (BASE + 43),
			NO_CLOSING_QUOTE = (BASE + 38),
			NO_ELEMENT_ALLOWED = (BASE + 45),
			NO_IDENTITY = (BASE + 94),
			NO_INTEGER = (BASE + 56),
			NO_WINDOW = (BASE + 90),
			NONAPPLICABLE_FUNCTION = (BASE + 46),
			NOTIFY_ON_AUTO_OPEN = (BASE + 44),
			NULL_PARAMETER_BLOCK = (BASE + 41),
			OUT_OF_MEMORY = (BASE + 8),
			OUTOFRANGE = (BASE + 26),
			PARAM_OVERFLOW = (BASE + 12),
			PARSER_INTERNAL = (BASE + 15),
			SEQ_DIV_INCOMPATIBLE = (BASE + 80),
			SEQ_NOMIDIPRESENT = (BASE + 87),
			SEQ_PORT_INUSE = (BASE + 81),
			SEQ_PORT_MAPNODEVICE = (BASE + 83),
			SEQ_PORT_MISCERROR = (BASE + 84),
			SEQ_PORT_NONEXISTENT = (BASE + 82),
			SEQ_PORTUNSPECIFIED = (BASE + 86),
			SEQ_TIMER = (BASE + 85),
			SET_CD = (BASE + 52),
			SET_DRIVE = (BASE + 53),
			UNNAMED_RESOURCE = (BASE + 42),
			UNRECOGNIZED_COMMAND = (BASE + 5),
			UNRECOGNIZED_KEYWORD = (BASE + 3),
			UNSUPPORTED_FUNCTION = (BASE + 18),
			VCR_CAMERA_MODE = (CUSTOM_DRIVER_BASE + 10),
			VCR_CANNOT_OPEN_COMM = (CUSTOM_DRIVER_BASE + 1),
			VCR_CANNOT_WRITE_COMM = (CUSTOM_DRIVER_BASE + 2),
			VCR_COMMAND_BUFFER_FULL = (CUSTOM_DRIVER_BASE + 4),
			VCR_COMMAND_CANCELLED = (CUSTOM_DRIVER_BASE + 5),
			VCR_COMMAND_FAILED = (CUSTOM_DRIVER_BASE + 7),
			VCR_CONDITION = (CUSTOM_DRIVER_BASE + 9),
			VCR_COUNTER_TYPE = (CUSTOM_DRIVER_BASE + 12),
			VCR_CUE_FAILED_FLAGS = (CUSTOM_DRIVER_BASE + 18),
			VCR_EMERGENCY_STOP = (CUSTOM_DRIVER_BASE + 14),
			VCR_ISWRITEPROTECTED = (CUSTOM_DRIVER_BASE + 19),
			VCR_MEDIA_UNMOUNTED = (CUSTOM_DRIVER_BASE + 15),
			VCR_POWER_OFF = (CUSTOM_DRIVER_BASE + 6),
			VCR_READ_TIMEOUT = (CUSTOM_DRIVER_BASE + 3),
			VCR_REGISTER = (CUSTOM_DRIVER_BASE + 16),
			VCR_SEARCH = (CUSTOM_DRIVER_BASE + 8),
			VCR_TRACK_FAILURE = (CUSTOM_DRIVER_BASE + 17),
			VCR_TUNER = (CUSTOM_DRIVER_BASE + 13),
			VCR_VCR_MODE = (CUSTOM_DRIVER_BASE + 11),
			WAVE_INPUTSINUSE = (BASE + 66),
			WAVE_INPUTSUNSUITABLE = (BASE + 72),
			WAVE_INPUTUNSPECIFIED = (BASE + 69),
			WAVE_OUTPUTSINUSE = (BASE + 64),
			WAVE_OUTPUTSUNSUITABLE = (BASE + 70),
			WAVE_OUTPUTUNSPECIFIED = (BASE + 68),
			WAVE_SETINPUTINUSE = (BASE + 67),
			WAVE_SETINPUTUNSUITABLE = (BASE + 73),
			WAVE_SETOUTPUTINUSE = (BASE + 65),
			WAVE_SETOUTPUTUNSUITABLE = (BASE + 71),

		}

		static bool HasOpenedCd = false;

		[DllImport("winmm.dll", EntryPoint = "mciSendStringA")]
		private static extern MciError mciSendString(
			string lpstrCommand,
			IntPtr lpstrReturnString, int uReturnLength, IntPtr hwndCallback);

		public static void Play(int track) {
			if (HasOpenedCd) mciSendString("close cdaudio", IntPtr.Zero, 0, IntPtr.Zero);
			mciSendString("open cdaudio", IntPtr.Zero, 0, IntPtr.Zero);
			HasOpenedCd = true;
			mciSendString("set cdaudio time format tmsf", IntPtr.Zero, 0, IntPtr.Zero);
			mciSendString(string.Format("play cdaudio from {0} to {1}", track, track + 1), IntPtr.Zero, 0, IntPtr.Zero);
		}
	}
}
